/*******************************************************************
 *
 *	Copyright (c) 1994-1999 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	File: kgsha.h
 *	Revision:  $Id: kgsha.h,v 1.2 2002/10/29 07:11:46 crypt Rel-1.6-3 $
 *	Created:
 *	Description: main header file of the libkgsha with the 
 *		functions that may be called from external programs
 *
 *******************************************************************/

#ifndef __KGSHA__
#define __KGSHA__

BOOL GetNameAndVersion( 
			char  *Name, 
			DWORD  nameSize, 
			DWORD *Major, 
			DWORD *Minor 
			);


BOOL CreateKeyHandle(
		ALG_SERV Alg,		/* what Encryption Algorithm will use the encryption key */
		DWORD	AlgKeyLength,	/* encryption key length for the Encryption Algorithm */
		char	*Text,		/* Any information text (optional parameter) */
		char	*Caption,	/* Caption of the "get password" dialog window (optional parameter) */
		DWORD	CreateFlag,	/* whether to create new key or open existing */
		BYTE	**vDataBlock,	/* block of data that is stored inside file-container in encrypted form */
		DWORD	*DataSize,	/* size of the block of data */
		DWORD	*KeyHandle,	/* returned Key Handle */
		DWORD	*ErrorCode	/* if the function returns FALSE, look at the Error code */
		);


BOOL CreateKeyHandleEx(
        ALG_SERV Alg,		    /* what Encryption Algorithm will use the encryption key */
		DWORD	AlgKeyLength,	// encryption key length for the Encryption Algorithm
		char	*Text,			// Text, containing filename of the container
		char	*Caption,		// Caption of the "get password" dialog window
		DWORD	CreateFlag,		// whether to create new key or open existing
		BYTE	**vDataBlock,	// block of data that is stored inside file-container in encrypted form
		DWORD	*DataSize,		// size of the block of data
		DWORD	*KeyHandle,		// returned Key Handle
		DWORD	*ErrorCode,		// if the function returns FALSE, look at the Error code
		DWORD	*DataOffset
		);


DWORD FreeDataBlock( BYTE **vDataBlock );

DWORD FreeKeyHandle( 
		ALG_SERV Alg,
		DWORD KeyHandle 
		);

#endif 
/* __KGSHA__                  */
