#ifndef __BC_3DES
#define __BC_3DES

#include "bc_types.h"
#include "bc_des.h"

#define SERVICE_NAME	"BC_3DES"
#define DISPLAY_NAME    "3DES"
#define ALGORITHM_ID     0xD0

// Key length in bites
#define DES_KEYS_IN_TRIPLE_DES 3

#define KEY_LENGTH          (KEY_LENGTH_DES          * DES_KEYS_IN_TRIPLE_DES)
#define KEY_LENGTH_EXTENDED (KEY_LENGTH_EXTENDED_DES * DES_KEYS_IN_TRIPLE_DES)
#define BLOCK_LENGTH     8                                                                                                    

#define DRIVER_MAJOR_VERSION	1
#define DRIVER_MINOR_VERSION	1

/******* Exported functions *********/


BOOL
KeyExtend( PUCHAR KeySource,
           PDWORD KeyDestination );

VOID
Encrypt( DWORD *IVector, 
         DWORD *KeyAdress,
         DWORD *SrcBuffer,
         DWORD *DstBuffer,
         DWORD Length );    // in bytes

VOID
Decrypt( DWORD *IVector, 
         DWORD *KeyAdress,
         DWORD *SrcBuffer,
         DWORD *DstBuffer,
         DWORD Length );    // in bytes


//
// Additional declaration of Tripple DES in ECB mode, necessary to
// test the Tripple DES implementation;
//

void DES3_ECB_mode( BYTE  *Input,       /* 8 bytes of input data              */
                   BYTE  *Output,      /* 8 bytes of output data             */
                   DWORD *KeySchedule, /* [16][2] array of DWORDs            */ 
                   BYTE  Operation);    /* DES_ECB_ENCRYPT or DES_ECB_DECRYPT */


#endif
