/*******************************************************************
 *	Copyright (c) 1994-1998 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	File:		driver/bc_mgr.h
 *
 *	Description:	algorithm manager data structures
 *
 *	Scope:		BestCrypt pseudo-device driver
 *
 *	Platforms:	Linux
 * 
 *	Author:		Nail R. Kaipov
 *
 *	Created:	10-Nov-1998
 *
 *	Revision:	
 *
 *******************************************************************/
 
#ifndef __BC_MGR_H__
#define __BC_MGR_H__

#define BC_ALGO_NAME_LEN	32

/* used for algorithm registration */
       
struct bc_algorithm {
	ALG_ID	id;
	DWORD	keylen; 
	char	*name;

	/* standard algorithm interface */
	int	(*make_key)(u_char *key, u_int keylen, u_char *pool, KEY_HANDLE *kh);
	int	(*test_key)(KEY_HANDLE kh);
	int	(*free_key)(KEY_HANDLE kh);
	int	(*lock_key)(KEY_HANDLE kh, int lock);
	int	(*encrypt) (KEY_HANDLE kh, u_char *iv, u_char *src, u_char *dst, u_int len);
	int	(*decrypt) (KEY_HANDLE kh, u_char *iv, u_char *src, u_char *dst, u_int len);
};

extern int 	init_bc_algo		();
extern int 	register_bc_algo	(struct bc_algorithm *algo);
extern int 	unregister_bc_algo	(ALG_ID algo_id);
extern struct bc_algorithm *get_bc_algo (ALG_ID algo_id, char *module_name);

extern int proc_bc_conf(char *page, char **start, off_t off, int count, int *eof, void *data);

#endif /* __BC_MGR_H__ */

