#ifndef __BC_DES
#define __BC_DES

#include "bc_types.h"
#define SERVICE_NAME	"BC_DES"
#define DISPLAY_NAME    "DES"
#define BLOCK_LENGTH	 8
#define ALGORITHM_ID     0x40

// Key length in bits
#define KEY_LENGTH          (64)
#define KEY_LENGTH_EXTENDED (128*8)

#define DRIVER_MAJOR_VERSION	1
#define DRIVER_MINOR_VERSION	1

#define DES_ECB_ENCRYPT 0
#define DES_ECB_DECRYPT 1

/******* Exported functions *********/


BOOL
KeyExtend( PUCHAR KeySource,          // 8       8-bit  uchars
           PDWORD KeyDestination );   // (128/4) 32-bit dwords

VOID
Encrypt( DWORD *IVector, 
         DWORD *KeyAdress,
         DWORD *SrcBuffer,
         DWORD *DstBuffer,
         DWORD Length );    // in bytes

VOID
Decrypt( DWORD *IVector, 
         DWORD *KeyAdress,
         DWORD *SrcBuffer,
         DWORD *DstBuffer,
         DWORD Length );    // in bytes

#endif

