  /* 
   *  The DUMMY algorithm driver does NOT encrypt data, it only copies data
   *  from SrcBuffer (source buffer) to DstBuffer (destination buffer).
   *
   *  You may insert your own encryption algorithm implementation to the 
   *  procedure, as well as your own Initial Vector calculation which 
   *  may be based on the IVector calculations made by other modules 
   *  of BestCrypt. Everything will work correctly, because the algorithm 
   *  driver is the only module in BestCrypt responsible for encryption.
   */

#include "bc_types.h"
/*
#ifndef __WIN95__
#include <windef.h>
#else
#include <basedef.h>
#endif
*/
#include "bc_dummy.h"

VOID
Encrypt( DWORD *IVector, 
         DWORD *KeyAddress,
         DWORD *SrcBuffer,
         DWORD *DstBuffer,
         DWORD Length )    // in bytes
{ 
  DWORD i, lengthDword = Length >> 2;

  for ( i=0; i < lengthDword; i++) DstBuffer[i] = SrcBuffer[i];
}

VOID
Decrypt( DWORD *IVector, 
         DWORD *KeyAddress,
         DWORD *SrcBuffer,
         DWORD *DstBuffer,
         DWORD Length )    // in bytes
{
  DWORD i, lengthDword = Length >> 2;

  for ( i=0; i < lengthDword; i++) DstBuffer[i] = SrcBuffer[i];
}

BOOL
KeyExtend( PUCHAR KeySource,
           PDWORD KeyDestination )
{
  return TRUE;
}

