/*******************************************************************
*
*      Copyright (c) 1994-1999 Jetico, Inc., Finland
*      All rights reserved.
*
*      File: bccreate.c
*      Revision: $Id: header.h,v 1.3 2002/10/29 07:11:31 crypt Rel-1.6-3 $
*      Created:
*      Description: definition of container header structure
*
*******************************************************************/
 
#ifndef __HEADER_H__
#define __HEADER_H__

#include <bc_types.h>

struct BPB
{
	WORD sectSize;
	BYTE sectPerCluster;
	WORD reservedSectors;
	BYTE NumberOfFat;
	WORD maxRootDirEntry;
	WORD totalSectors;
	BYTE mediaDesc;
	WORD sectorsPerFat;
	WORD sectorsPerTrack;
	WORD numberOfHeads;
	DWORD hiddenSectors;
	DWORD totalSectorsLong;
} __attribute__ ((packed));

struct BootRecord {
	BYTE jmpCode[3];
	char OEMid[8];

	struct BPB bpb;
	BYTE driveNo; // 0, 80h
	BYTE reserved;
	BYTE extBootSign;
	DWORD serialNumber;
	char volumeLabel[11];
	char FatType[8];
	   
//------------------- end of boot record (size=62 bytes)
}__attribute__ ((packed));


#define HiddenSectorSize 512
#define KeyDataSize 4
#define SignatureSize 8

struct HiddenSector{

  struct BootRecord br;
  char description[66];
  WORD extent;
  WORD version;
  BYTE keyData[KeyDataSize];

  BYTE reserved[HiddenSectorSize -
               sizeof(struct BootRecord)-
               66 - // sizeof(description)-
               2 -  // sizeof(extent)-
               2 -  // sizeof(version)-
			   KeyDataSize -  // sizeof(keyData)-
			   4 -	// dwKeySize
			   4 -  // dwDataOffset
			   4 -  // fileSystemId
               4 -  // algorithmId
			   4 -	// keyGenId
               8];

  DWORD dwKeySize;		// Key size. Key is to be placed just after hidden sector in container...
  DWORD dwDataOffset;	// Encrypted Data offset from file begining in bytes...
  DWORD fileSystemId;	// Driver will mark container during formating formating...
  DWORD algorithmId;	// Encryption Algorithm identifier.  
  DWORD keyGenId;		// Key generation identifier...
  char signature[ SignatureSize ];
}__attribute__ ((packed));


#endif /* __HEADER_H__ */

 

